Unit ADS3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFS3C_p;

procedure ADS3C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; var RI :Array of Integer;
                var R :Array of Real; N :Integer);

implementation

procedure ADS3C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; var RI :Array of Integer;
                var R :Array of Real; N :Integer);
var
IERR,I,K,LI,M,L :Integer;
label
_1,_2,_3,_4,_5,_6;
begin
AFS3C(A,N,RI,R,IERR);
if ( IERR <= 65 ) 
 then goto _1;
D1 := Cmplx(0.0,0.0);
D2 := 0;
goto _6;
_1:
K := 0;
D1 := Cmplx(1.0,0.0);
D2 := 0;
for I:=1 to N do
 begin
  K := K+I;
  LI := I+N;
  if ( RI[LI-1] = 1.0 ) 
   then goto _2;
  if ( RI[LI-1] = 0.0 ) 
   then goto _5;
  L := K+I+1;
  M := L-1;
  D1 := MulC(D1,SubC(MulC(A[K-1],A[L-1]),Cpower(A[M-1],2)));
  goto _3;
_2:
  D1 := MulC(D1,A[K-1]);
_3:
  if ( Cabs(D1) < 1.0 ) 
   then goto _4;
  D1 := MulC(D1,Cmplx(0.0625,0.0));
  D2 := D2+4;
  goto _3;
_4:
  if ( Cabs(D1) >= 0.0625 ) 
   then goto _5;
  D1 := MulC(D1,Cmplx(16.0,0.0));
  D2 := D2-4;
  goto _4;
_5:
 end;
_6:
end;

end.
